//
//  Rs[^Aj[V_
//  _̃TvvO
//

// GLUTwb_t@C̃CN[h
#include <GL/glut.h>


// O[oϐ

// EBhẼTCY
int  win_width, win_height;

// wiIuWFNg̈ʒu
const int  num_trees = 100;
float  tree_pos[ num_trees ][2];

// }EX̃hbÔ߂̕ϐ
int  drag_mouse_r = 0; // E{^hbOǂ̃tOi1:hbO, 0:hbOj
int  drag_mouse_l = 0; // {^hbOǂ̃tOi1:hbO, 0:hbOj
int  last_mouse_x, last_mouse_y; // ŌɋL^ꂽ}EXJ[\̍W


// _p^
float  view_center_x;  // _̈ʒu
float  view_center_y;  // _̈ʒu
float  view_center_z;  // _̈ʒu
float  view_yaw;	   // _̕ʊp
float  view_pitch;	 // _̋p
float  view_distance;  // _ƒ_̋


// _샂[h
enum  ViewControlModeEnum
{
	VIEW_DOLLY_PARAM,		 // Dolly[hi}ϐj
	VIEW_DOLLY_DIRECT,		// Dolly[hiڍXVj
	VIEW_SCROLL_PARAM,		// Scroll[hi}ϐj
	VIEW_SCROLL_DIRECT,	   // Scroll[hiڍXVj
	VIEW_WALKTHROUGH_PARAM,   // Walkthrough[hi}ϐj
	VIEW_WALKTHROUGH_DIRECT,  // Walkthrough[hiڍXVj
	NUM_VIEW_CONTROL_MODES	// _샂[h̎ސ
};

// _샂[h̖O
const char *   mode_name[] = { "Dolly Mode (Parameter)", "Dolly Mode (Direct)", "Scroll Mode (Parameter)", "Scroll Mode (Direct)", "Walkthrough Mode (Parameter)", "Walkthrough Mode (Direct)" };

// ݂̎_샂[h
ViewControlModeEnum  mode = VIEW_DOLLY_PARAM;



//
//  _̂߂̏
//


//
//  _̏
// iŏ̏Ǝ_[h؂ւꂽƂɌĂ΂j
//
void  InitView()
{
	// _p^
	if ( mode == VIEW_DOLLY_PARAM )
	{
		view_center_x = 0.0f;
		view_center_y = 0.0f;
		view_center_z = 0.0f;
		view_yaw = -30.0f;
		view_pitch = -30.0f;
		view_distance = 15.0f;
	}
	if ( mode == VIEW_SCROLL_PARAM )
	{
		view_center_x = 0.0f;
		view_center_y = 0.0f;
		view_center_z = 0.0f;
		view_yaw = 0.0f;
		view_pitch = -30.0f;
		view_distance = 15.0f;
	}
	if ( mode == VIEW_WALKTHROUGH_PARAM )
	{
		view_center_x = 0.0f;
		view_center_y = 0.5f;
		view_center_z = 0.0f;
		view_yaw = 0.0f;
		view_pitch = 0.0f;
		view_distance = 0.0f;
	}

	// ϊs
	if ( mode == VIEW_DOLLY_DIRECT )
	{
		glMatrixMode( GL_MODELVIEW );
		glLoadIdentity();
		glTranslatef( 0.0, 0.0, -15.0 );
		glRotatef( 30.0, 1.0, 0.0, 0.0 );
		glRotatef( 30.0, 0.0, 1.0, 0.0 );

		view_center_x = 0.0f;
		view_center_y = 0.0f;
		view_center_z = 0.0f;
	}
	if ( mode == VIEW_SCROLL_DIRECT )
	{
		glMatrixMode( GL_MODELVIEW );
		glLoadIdentity();
		glTranslatef( 0.0, 0.0, -15.0 );
		glRotatef( 30.0, 1.0, 0.0, 0.0 );
		glRotatef( 0.0, 0.0, 1.0, 0.0 );

		view_center_x = 0.0f;
		view_center_y = 0.0f;
		view_center_z = 0.0f;
	}
	if ( mode == VIEW_WALKTHROUGH_DIRECT )
	{
		glMatrixMode( GL_MODELVIEW );
		glLoadIdentity();
		glTranslatef( 0.0, -0.5, 0.0 );
		glRotatef( 0.0, 1.0, 0.0, 0.0 );
		glRotatef( 0.0, 0.0, 1.0, 0.0 );
	}
}


//
//  _p^ɉĕϊsiJWn烏[hWnւ̕ϊsjXV
// iʕ`掞̃R[obN֐ DisplayCallback() Ă΂j
//
void  UpdateViewMatrix()
{
	// _p^g쎞̂ݕϊsXV
 	if ( ( mode == VIEW_DOLLY_PARAM ) || ( mode == VIEW_SCROLL_PARAM ) || ( mode == VIEW_WALKTHROUGH_PARAM ) )
	{
		glMatrixMode( GL_MODELVIEW );
		glLoadIdentity();
		glTranslatef( 0.0,  0.0, - view_distance );
		glRotatef( - view_pitch, 1.0, 0.0, 0.0 );
		glRotatef( - view_yaw, 0.0, 1.0, 0.0 );
		glTranslatef( - view_center_x, - view_center_y, - view_center_z );
	}
}


//
//  }EXɉĎ_p^ or ϊsXV
// i}EXhbÕR[obN֐ MouseDragCallback() Ă΂j
//
void  UpdateView( int delta_mouse_right_x, int delta_mouse_right_y, int delta_mouse_left_x, int delta_mouse_left_y )
{
	// _p^XViDolly[hE}ϐj
	if ( mode == VIEW_DOLLY_PARAM )
	{
		// ̉E{^hbOɉāA_𐅕ɉ]
		if ( delta_mouse_right_x != 0 )
		{
			view_yaw -= delta_mouse_right_x * 1.0;

			// p^̒l͈̔͂𒴂Ȃ悤ɏC
			if ( view_yaw < 0.0 )
				view_yaw += 360.0;
			else if ( view_yaw > 360.0 )
				view_yaw -= 360.0;
		}

		// c̉E{^hbOɉāA_㉺ɉ]
		if ( delta_mouse_right_y != 0 )
		{
			view_pitch -= delta_mouse_right_y * 1.0;

			// p^̒l͈̔͂𒴂Ȃ悤ɏC
			if ( view_pitch < -90.0 )
				view_pitch = -90.0;
			else if ( view_pitch > -2.0 )
				view_pitch = -2.0;
		}
		
		// c̍{^hbOɉāA_ƒ_̋ύX
		if ( delta_mouse_left_y != 0 )
		{
			view_distance += delta_mouse_left_y * 0.2;

			// p^̒l͈̔͂𒴂Ȃ悤ɏC
			if ( view_distance < 5.0 )
				view_distance = 5.0;
		}
	}

	// _p^XViScroll[hE}ϐj
	if ( mode == VIEW_SCROLL_PARAM )
	{
		// c̉E{^hbOɉāA_㉺ɉ]
		if ( delta_mouse_right_y != 0 )
		{
			// |[gۑ
		}

		// {^hbOɉāA_O㍶EɈړi[hWnƂO㍶Ej
		if ( ( delta_mouse_left_x != 0 ) || ( delta_mouse_left_y != 0 ) )
		{
			// |[gۑ
		}
	}

	// _p^XViWalkthrough[hE}ϐj
	if ( mode == VIEW_WALKTHROUGH_PARAM )
	{
		// ̉E{^hbOɉāA_𐅕ɉ]
		if ( delta_mouse_right_x != 0 )
		{
			// |[gۑ
		}

		// {^hbOɉāA_O㍶EɈړiJ̌ƂO㍶Ej
		if ( ( delta_mouse_left_x != 0 ) || ( delta_mouse_left_y != 0 ) )
		{
			// |[gۑ
		}
	}

	// ϊsXViDolly[hEڍXVj
	if ( mode == VIEW_DOLLY_DIRECT )
	{
		// ̉E{^hbOɉāA_𐅕ɉ]
		if ( delta_mouse_right_x != 0 )
		{
			// _̐̉]ʂvZ
			float  delta_yaw = delta_mouse_right_x * 1.0;

			// ݂̕ϊs̉EɁẢ]ϊ
			glMatrixMode( GL_MODELVIEW );
			glRotatef( delta_yaw, 0.0, 1.0, 0.0 );
		}

		// c̉E{^hbOɉāA_㉺ɉ]
		if ( delta_mouse_right_y != 0 )
		{
			// _̏㉺̉]ʂvZ
			float  delta_pitch = delta_mouse_right_y * 1.0;

			// ݂̕ϊs擾
			float  m[ 16 ];
			float  tx, ty, tz;
			glGetFloatv( GL_MODELVIEW_MATRIX, m );

			// ݂̕ϊs̕sړL^
			tx = m[ 12 ];
			ty = m[ 13 ];
			tz = m[ 14 ];

			// ݂̕ϊs̕sړOɂ
			m[ 12 ] = 0.0f;
			m[ 13 ] = 0.0f;
			m[ 14 ] = 0.0f;

			// ϊs
			glMatrixMode( GL_MODELVIEW );
			glLoadIdentity();

			// J̕sړsݒ
			glTranslatef( tx, ty, tz );

			// EɁẢ]ϊ
			glRotatef( delta_pitch, 1.0, 0.0, 0.0 );

			// ɁAEɁAƂ̕ϊs񂩂畽sړƂ菜̂
			glMultMatrixf( m );
		}

		// c̍{^hbOɉāA_ƒ_̋ύX
		if ( delta_mouse_left_y )
		{
			// _ƒ_̋̕ωʂvZ
			float  delta_dist = delta_mouse_left_y * 1.0;

			// ݂̕ϊsiJ̌j擾
			float  m[ 16 ];
			glGetFloatv( GL_MODELVIEW_MATRIX, m );

			// ϊsāAJړ̕sړsݒ
			glMatrixMode( GL_MODELVIEW );
			glLoadIdentity();
			glTranslatef( 0.0,  0.0, - delta_dist );

			// E炱܂ł̕ϊs
			glMultMatrixf( m );
		}
	}

	// _p^XViScroll[hEڍXVj
	if ( mode == VIEW_SCROLL_DIRECT )
	{
		// c̉E{^hbOɉāA_㉺ɉ]
		if ( delta_mouse_right_y != 0 )
		{
			// |[gۑ
		}

		// {^hbOɉāA_O㍶EɈړi[hWnƂđO㍶EɈړj
		if ( ( delta_mouse_left_x != 0 ) || ( delta_mouse_left_y != 0 ) )
		{
			// |[gۑ
		}
	}

	// ϊsXViWalkthrough[hEڍXVj
	if ( mode == VIEW_WALKTHROUGH_DIRECT )
	{
		// ̉E{^hbOɉāA_𐅕ɉ]
		if ( delta_mouse_right_x != 0 )
		{
			// |[gۑ
		}

		// {^hbOɉāA_O㍶EɈړiJ̌ƂđO㍶EɈړj
		if ( ( delta_mouse_left_x != 0 ) || ( delta_mouse_left_y != 0 ) )
		{
			// |[gۑ
		}
	}
}



//
//  ȉAvÕC
//


//
//  ؂`
//
void  RenderTree()
{
	static GLUquadricObj *  quad_obj = NULL;
	if ( quad_obj == NULL )
		quad_obj = gluNewQuadric();

	glPushMatrix();
		glRotatef( -90.0f, 1.0f, 0.0f, 0.0f );
		glColor3f( 0.8, 0.7, 0.0 );
		gluCylinder( quad_obj, 0.25f, 0.25f, 1.0f, 16, 1 );
	glPopMatrix();

	glPushMatrix();
		glTranslatef( 0.0f, 0.5f, 0.0f );
		glRotatef( -90.0f, 1.0f, 0.0f, 0.0f );
		glColor3f( 0.3, 0.7, 0.3 );
		gluCylinder( quad_obj, 0.5f, 0.0f, 1.0f, 16, 1 );
	glPopMatrix();

	glPushMatrix();
		glTranslatef( 0.0f, 1.0f, 0.0f );
		glRotatef( -90.0f, 1.0f, 0.0f, 0.0f );
		glColor3f( 0.3, 0.7, 0.3 );
		gluCylinder( quad_obj, 0.5f, 0.0f, 1.0f, 16, 1 );
	glPopMatrix();
}


//
//  iq͗l̏`
//
void  DrawFloor( int tile_size, int num_x, int num_z, float r0, float g0, float b0, float r1, float g1, float b1 )
{
	int  x, z;
	float  ox, oz;

	glBegin( GL_QUADS );
	glNormal3d( 0.0, 1.0, 0.0 );

	ox = - ( num_x * tile_size ) / 2;
	for ( x=0; x<num_x; x++ )
	{
		oz = - ( num_z * tile_size ) / 2;
		for ( z=0; z<num_z; z++ )
		{
			if ( ( (x + z) % 2 ) == 0 )
				glColor3f( r0, g0, b0 );
			else
				glColor3f( r1, g1, b1 );

			glTexCoord2d( 0.0f, 0.0f );
			glVertex3d( ox, 0.0, oz );
			glTexCoord2d( 0.0f, 1.0f );
			glVertex3d( ox, 0.0, oz + tile_size );
			glTexCoord2d( 1.0f, 1.0f );
			glVertex3d( ox + tile_size, 0.0, oz + tile_size );
			glTexCoord2d( 1.0f, 0.0f );
			glVertex3d( ox + tile_size, 0.0, oz );

			oz += tile_size;
		}
		ox += tile_size;
	}
	glEnd();
}


//
//  ĩ݂[hj`
//
void  DrawTextInformation()
{
	// \郁bZ[W
	int   i;
	const char *  message = mode_name[ mode ];

	// ˉesȋOɌ݂̍sޔj
	glMatrixMode( GL_PROJECTION );
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D( 0.0, win_width, win_height, 0.0 );

	// fr[sȋOɌ݂̍sޔj
	glMatrixMode( GL_MODELVIEW );
	glPushMatrix();
	glLoadIdentity();

	// yobt@ECeBO̓Itɂ
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_LIGHTING );

	// bZ[W̕`
	glColor3f( 1.0, 0.0, 0.0 );
	glRasterPos2i( 16, 16 + 18 );
	for ( i=0; message[i]!='\0'; i++ )
		glutBitmapCharacter( GLUT_BITMAP_HELVETICA_18, message[i] );

	// ݒSĕ
	glEnable( GL_DEPTH_TEST );
	glEnable( GL_LIGHTING );
	glMatrixMode( GL_PROJECTION );
	glPopMatrix();
	glMatrixMode( GL_MODELVIEW );
	glPopMatrix();
}


//
//  ʕ`掞ɌĂ΂R[obN֐
//
void  DisplayCallback()
{
	// ʂNAisNZf[^Ƃyobt@̗NAj
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	
	// _p^ɉĕϊsiJWn烏[hWnւ̕ϊsjXV
	UpdateViewMatrix();

	// ʒuݒifr[s̕ύXɂ킹čĐݒj
	float  light0_position[] = { 10.0, 10.0, 10.0, 1.0 };
	glLightfv( GL_LIGHT0, GL_POSITION, light0_position );

	// iq͗l̏`
	DrawFloor( 1.0f, 50, 50, 1.0, 1.0, 1.0, 0.8, 0.8, 0.8 );

	// wi̖؂`
	int  i;
	for ( i=0; i<num_trees; i++ )
	{
		glPushMatrix();
		glTranslatef( tree_pos[ i ][ 0 ], 0.0f, tree_pos[ i ][ 1 ] );
		RenderTree();
		glPopMatrix();
	}

	// _ɃIuWFNgij`
	if ( ( mode != VIEW_WALKTHROUGH_PARAM ) && ( mode != VIEW_WALKTHROUGH_DIRECT ) )
	{
		glPushMatrix();
		glTranslatef( view_center_x, view_center_y + 0.5f, view_center_z );
		glColor3f( 1.0, 0.0, 0.0 );
		glutSolidSphere( 0.5f, 24, 12 );
		glPopMatrix();
	}

	// ĩ݂[hj`
	DrawTextInformation();

	// obNobt@ɕ`悵ʂtgobt@ɕ\
	glutSwapBuffers();
}


//
//  EBhETCYύXɌĂ΂R[obN֐
//
void  ReshapeCallback( int w, int h )
{
	// EBhE̕`s͈͂ݒił̓EBhEŜɕ`j
	glViewport(0, 0, w, h);
	
	// JWnXN[Wnւ̕ϊsݒ
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	gluPerspective( 45, (double)w/h, 1, 500 );

	// EBhẼTCYL^ieLXg`揈̂߁j
	win_width = w;
	win_height = h;
}


//
// }EXNbNɌĂ΂R[obN֐
//
void  MouseClickCallback( int button, int state, int mx, int my )
{
	// E{^ꂽhbOJn
	if ( ( button == GLUT_RIGHT_BUTTON ) && ( state == GLUT_DOWN ) )
		drag_mouse_r = 1;
	// E{^ꂽhbOI
	else if ( ( button == GLUT_RIGHT_BUTTON ) && ( state == GLUT_UP ) )
		drag_mouse_r = 0;

	// {^ꂽhbOJn
	if ( ( button == GLUT_LEFT_BUTTON ) && ( state == GLUT_DOWN ) )
		drag_mouse_l = 1;
	// {^ꂽhbOI
	else if ( ( button == GLUT_LEFT_BUTTON ) && ( state == GLUT_UP ) )
		drag_mouse_l = 0;

	// ݂̃}EXWL^
	last_mouse_x = mx;
	last_mouse_y = my;
}


//
// }EXhbOɌĂ΂R[obN֐
//
void  MouseDragCallback( int mx, int my )
{
	// }EX̃hbOvZ
	int  delta_mouse_right_x = 0, delta_mouse_right_y = 0, delta_mouse_left_x = 0, delta_mouse_left_y = 0;
	if ( drag_mouse_r )
	{
		delta_mouse_right_x = mx - last_mouse_x;
		delta_mouse_right_y = my - last_mouse_y;
	}
	if ( drag_mouse_l )
	{
		delta_mouse_left_x = mx - last_mouse_x;
		delta_mouse_left_y = my - last_mouse_y;
	}

	// }EXɉĎ_p^ or ϊsXV
	UpdateView( delta_mouse_right_x, delta_mouse_right_y, delta_mouse_left_x, delta_mouse_left_y );

	// ̃}EXWL^
	last_mouse_x = mx;
	last_mouse_y = my;

	// ĕ`̎woǐōĕ`̃R[obN֐Ă΂j
	glutPostRedisplay();
}


//
//  L[{[h̃L[ꂽƂɌĂ΂R[obN֐
//
void  KeyboardCallback( unsigned char key, int mx, int my )
{
	// ML[Ŏ_샂[hԂɐ؂ւ
	if ( key == 'm' )
	{
		// ̎_샂[hɐ؂ւ
		mode = (ViewControlModeEnum)( ( mode + 1 ) % NUM_VIEW_CONTROL_MODES );

		// _̏
		InitView();
	}

	// ĕ`̎woǐōĕ`̃R[obN֐Ă΂j
	glutPostRedisplay();
}


//
//  ֐
//
void  InitEnvironment()
{
	// 쐬
	float  light0_position[] = { 10.0, 10.0, 10.0, 1.0 };
	float  light0_diffuse[] = { 0.8, 0.8, 0.8, 1.0 };
	float  light0_specular[] = { 1.0, 1.0, 1.0, 1.0 };
	float  light0_ambient[] = { 0.1, 0.1, 0.1, 1.0 };
	glLightfv( GL_LIGHT0, GL_POSITION, light0_position );
	glLightfv( GL_LIGHT0, GL_DIFFUSE, light0_diffuse );
	glLightfv( GL_LIGHT0, GL_SPECULAR, light0_specular );
	glLightfv( GL_LIGHT0, GL_AMBIENT, light0_ambient );
	glEnable( GL_LIGHT0 );

	// vZLɂ
	glEnable( GL_LIGHTING );

	// ̂̐FLɂ
	glEnable( GL_COLOR_MATERIAL );

	// yeXgLɂ
	glEnable( GL_DEPTH_TEST );

	// wʏLɂ
	glCullFace( GL_BACK );
	glEnable( GL_CULL_FACE );

	// wiFݒ
	glClearColor( 0.5, 0.5, 0.8, 0.0 );

	// wiɔzuc[̈ʒu_ɏ
	for ( int i=0; i<num_trees; i++ )
	{
		for ( int j=0; j<2; j++ )
			tree_pos[ i ][ j ] = ( rand() % 1000 - 500 ) * 0.04f;
	}
}


//
//  C֐ivO͂Jnj
//
int  main( int argc, char ** argv )
{
	// GLUT̏
	glutInit( &argc, argv );
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA );
	glutInitWindowSize( 640, 640 );
	glutInitWindowPosition( 0, 0 );
	glutCreateWindow("View Control");
	
	// R[obN֐̓o^
	glutDisplayFunc( DisplayCallback );
	glutReshapeFunc( ReshapeCallback );
	glutMouseFunc( MouseClickCallback );
	glutMotionFunc( MouseDragCallback );
	glutKeyboardFunc( KeyboardCallback );

	// 
	InitEnvironment();

	// _̏
	InitView();

	// GLUT̃C[vɏڂ
	glutMainLoop();
	return 0;
}

